package org.distributeme.registry.ui;

import net.anotheria.maf.MAFFilter;
import net.anotheria.maf.action.ActionMappingsConfigurator;
import org.apache.log4j.Logger;

import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import java.util.Arrays;
import java.util.List;

/**
 * Base filter for UI functionality.
 *
 * @author dsilenko
 */
public class UIFilter extends MAFFilter {

	/**
	 * Default logger.
	 */
	private static final Logger log = Logger.getLogger(UIFilter.class);

	@Override
	public void init(FilterConfig config) throws ServletException {
		log.info("Initializing UIFilter...");
		super.init(config);
	}

	@Override
	protected List<ActionMappingsConfigurator> getConfigurators() {
		return Arrays.asList(new ActionMappingsConfigurator[]{new BaseActionsConfigurator()});
	}
	@Override
	protected String getDefaultActionName() {
		return "registry";
	}

}
